/*******************************************************************/
/*                                                                 */
/*                      ADOBE CONFIDENTIAL                         */
/*                   _ _ _ _ _ _ _ _ _ _ _ _ _                     */
/*                                                                 */
/* Copyright 2003-2007 Adobe Systems Incorporated                  */
/* All Rights Reserved.                                            */
/*                                                                 */
/* NOTICE:  All information contained herein is, and remains the   */
/* property of Adobe Systems Incorporated and its suppliers, if    */
/* any.  The intellectual and technical concepts contained         */
/* herein are proprietary to Adobe Systems Incorporated and its    */
/* suppliers and may be covered by U.S. and Foreign Patents,       */
/* patents in process, and are protected by trade secret or        */
/* copyright law.  Dissemination of this information or            */
/* reproduction of this material is strictly forbidden unless      */
/* prior written permission is obtained from Adobe Systems         */
/* Incorporated.                                                   */
/*                                                                 */
/*******************************************************************/

typedef signed __int64		int64_t;
typedef unsigned __int64	uint64_t;

typedef struct riffstuff_tag
{
	HANDLE hFile;
	// OUTPUT
	char szCurrentList[8];
	int64_t dwListStart;
	char szCurrentChunk[8];
	int64_t dwChunkStart;
	// INPUT
	int64_t dwFullSize;
	int64_t dwChunksStart;
	SPECIALDATA spPending[10];
	int iNumSpecialPending;

} RIFFSTUFF;

typedef struct riffwave_t
{	
	int64_t dwOffset;		// start of current top level chunk
	DWORD dwChunkSize;		// size of current top level chunk
	int64_t dwListEnd;		// if in a LIST chunk, this is 1 past end of chunk
	int64_t dwSaveCursor;
	int64_t dwRiffLength;
} RIFFWAVEDATA;

void RiffStuffEnter(RIFFSTUFF * pRiff, LPCSTR szType);
void RiffStuffExit(RIFFSTUFF * pRiff);
DWORD RiffStuffWriteSpecialData(RIFFSTUFF * pRiff, LPCSTR szListType, LPCSTR szType, char * pData,DWORD dwSize);
DWORD RiffStuffGetNextSpecialData(RIFFSTUFF * pRiff, SPECIALDATA * psp);
DWORD RiffStuffGetFirstSpecialData(RIFFSTUFF * pRiff, SPECIALDATA * psp);
BOOL RiffStuffCloseOutput(RIFFSTUFF * pRiff);
BOOL RiffStuffOpenInput(RIFFSTUFF * pRiff, HANDLE hFile, int64_t dwFullSize, int64_t dwChunkStart);
BOOL RiffStuffOpenOutput(RIFFSTUFF * pRiff, HANDLE hFile, DWORD dwListStart);
DWORD SetFilePointer2(HANDLE hFile, DWORD dwLow, DWORD dwHigh, DWORD dwMethod);
int64_t SetFilePointer64(HANDLE hFile, int64_t qiMoveTo, DWORD dwMethod);

