/*******************************************************************/
/*                                                                 */
/*                      ADOBE CONFIDENTIAL                         */
/*                   _ _ _ _ _ _ _ _ _ _ _ _ _                     */
/*                                                                 */
/* Copyright 2003-2004 Adobe Systems Incorporated                  */
/* All Rights Reserved.                                            */
/*                                                                 */
/* NOTICE:  All information contained herein is, and remains the   */
/* property of Adobe Systems Incorporated and its suppliers, if    */
/* any.  The intellectual and technical concepts contained         */
/* herein are proprietary to Adobe Systems Incorporated and its    */
/* suppliers and may be covered by U.S. and Foreign Patents,       */
/* patents in process, and are protected by trade secret or        */
/* copyright law.  Dissemination of this information or            */
/* reproduction of this material is strictly forbidden unless      */
/* prior written permission is obtained from Adobe Systems         */
/* Incorporated.                                                   */
/*                                                                 */
/*******************************************************************/

//
// CPlugInSession.H
//

#pragma once

//////////////////////////////////////////////////////////////////////////////
//

// Forward declarations
struct COMPLETE_SESSION_INFO_NEW;
struct FULL_SDK_SESSION_INFO;


// For GetFlags()
#define PLUGINSES_CANOPEN		0x04
#define PLUGINSES_CANSAVE		0x08
#define PLUGINSES_HIDDEN		0x10		// hide this session in the open and save dialog.


class CPlugInSession
{
public:

	CPlugInSession() {};

	virtual ~CPlugInSession() {};

	virtual HRESULT GetFlags(DWORD * pdwFlags)
	{	return E_FAIL;		}

	virtual HRESULT Understands(LPCTSTR szName)
	{	return E_NOTIMPL;	}

	virtual HRESULT	ReadSession(LPCTSTR szFilename, FULL_SDK_SESSION_INFO** outSessionInfo)
	{	return E_NOTIMPL;	}

	virtual HRESULT	CloseSession(void)
	{	return E_NOTIMPL;	}

	virtual HRESULT	WriteSession(LPCTSTR szFilename, FULL_SDK_SESSION_INFO* inSessionInfo)
	{	return E_NOTIMPL;	}

};

typedef struct session_name_info_t
{
	DWORD 	dwSize;				// Must be populated with the size of this structure
	LPWSTR 	lpszSessionName; 	// Pointer to buffer to recieve session name
	DWORD	nSessionNameLen;	// Max length of lpszSessionName buffer, or number of bytes copied into lpszSessionName buffer on return from PlugInSessionGetName
	LPWSTR  lpszSessionExt;		// Pointer to buffer to recieve session extension
	DWORD	nSessionExtLen;		// Max length of lpszSessionExt buffer, or number of bytes copied into lpszSessionExt buffer on return from PlugInSessionGetName
} SESSION_NAME_INFO, *LPSESSION_NAME_INFO;

typedef HRESULT (WINAPI PLUGINSESSIONGETNAMEPROC)(LPSESSION_NAME_INFO lpSessionNameInfo);
typedef CPlugInSession * (WINAPI PLUGINSESSIONNEWPROC)(void);


//****************************************************************************
// EOF
